\documentclass[a4paper]{article}
\usepackage[english]{babel}
\usepackage[T1]{fontenc}
\usepackage[a4paper, top=0.75cm, bottom=0.75cm, left=2cm, right=2cm]{geometry}
\usepackage{listings}
\usepackage{inconsolata}
\pagenumbering{gobble}
\lstset{frame=single, showstringspaces=false, columns=fixed, basicstyle={\ttfamily}, commentstyle={\it}, numbers=left, tabsize=4}
\begin{document}
\lstset{title=Contents of \texttt{README}}
\lstset{
  language=,
  morekeywords={NAME, SYNOPSIS, DESCRIPTION, NOTES, EXAMPLES, AUTHOR, COPYRIGHT},
  moredelim=[is][\it]{<|}{|>},
  moredelim=[is][\bf]{<:}{:>}
}
\begin{lstlisting}
NAME
        <:swarm:> - create a swarm of workers, capable of executing small tasks,
            distributed between them.

SYNOPSIS
        <|TaskStream|> *<:makeTaskStream:>(char *[], size_t);
            Prepare the task stream from a NULL-terminated filename list and
            the size of processing block.
        int <:getTask:>(<|TaskStream|> *, <|Task|> *);
            Get the next task from the task stream.
        <|Swarm|> *<:makeSwarm:>(size_t);
            Create and initialize a swarm with a set amount of workers.
        void <:makeWorker:>(<|Worker|> *);
            Make a single worker.
        void <:pushTask:>(<|Worker|> *, <|Task|> *);
            Assign the worker a task.
        int <:popTask:>(<|Worker|> *, double *);
            Get the results of the last task from the worker (non-blocking).
        void <:workLoop:>(<|Worker|> *);
            Run the main worker loop.

DESCRIPTION
        Find the smallest double value in files supplied in the command line.
        Up to 10x performance boost, when compared to single-process bruteforce
        mmap method.

AUTHOR
        Implemented by Stotskii Andrey (ruro).

COPYRIGHT
        Copyright (c) 2017 Free Software Foundation, Inc.  License GPLv3+:
        GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>.
        This is free software: you are free to change and redistribute it.
        There is NO WARRANTY, to the extent permitted by law.
\end{lstlisting}
\lstset{title=Contents of \texttt{makefile}}
\lstset{language={[gnu]make}}
\begin{lstlisting}
CFLAGS= -Wall -O3 -std=gnu99
LDFLAGS= -s -lm -lpthread
CC=gcc

vpath %.c src
vpath %.h src

examples: swarm.h terminator.h swarm.o terminator.o forkshare.o
swarm.o:  swarm.h terminator.h forkshare.h
terminator.o:     terminator.h forkshare.h
forkshare.o:      terminator.h forkshare.h

.PHONY:libs
libs: swarm.o terminator.o forkshare.o

.PHONY:clean
clean:
	rm -f *.o examples
\end{lstlisting}
\newpage
\lstset{language={[ANSI]C}}
\lstset{literate={float.}{float.}6}
\lstset{morekeywords={size_t, ssize_t, bool, sem_t, Task, TaskStream, Worker, Swarm}}
\lstset{moredelim=[s][\it]{__}{__}}
\lstset{moredelim=[s][\it]{((}{))}}
\lstset{title=Contents of \texttt{src/swarm.h}}
\begin{lstlisting}
#ifndef _SWARM_H
#define _SWARM_H
#include <semaphore.h>
#include <stdbool.h>
#include <limits.h>

typedef struct {
    char filename[PATH_MAX];
    size_t offset;
    size_t amount;
} Task;

typedef struct {
    char **files;
    size_t step;
    size_t cur_file;
    size_t cur_off;
    size_t cur_max;
} TaskStream;

typedef struct {
    Task task;
    sem_t hastask;
    bool keepfile;
    bool alive;
    double result;
    sem_t hasresult;
} Worker;

typedef struct {
    size_t worker_num;
    Worker workers[];
} Swarm;

TaskStream *makeTaskStream(char *[], size_t) __attribute__ (( nonnull ));
int getTask(TaskStream *, Task *) __attribute__ (( nonnull ));
Swarm *makeSwarm(size_t);
void makeWorker(Worker *) __attribute__ (( nonnull ));
void pushTask(Worker *, Task *) __attribute__ (( nonnull ));
int popTask(Worker *, double *) __attribute__ (( nonnull ));
void workLoop(Worker *) __attribute__ (( nonnull ));

#endif
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/swarm.c}}
\begin{lstlisting}
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/mman.h>
#include <errno.h>
#include <unistd.h>
#include <float.h>
#include <string.h>
#include <stdio.h>
#include <malloc.h>

#include "swarm.h"
#include "terminator.h"
#include "forkshare.h"

int sem_getval_safe(sem_t *sem)
{
    int ret;
    if (sem_getvalue(sem, &ret))
        terminate(errno, "Semaphore is broken (getvalue).\n");
    return ret;
}

void sem_wait_safe(sem_t *sem)
{
    while (sem_wait(sem))
        if (errno != EINTR)
            terminate(errno, "Semaphore is broken (wait).\n");
}

int sem_trywait_safe(sem_t *sem)
{
    while (sem_trywait(sem))
    {
        if (errno == EINTR)
            continue; // Interrupted
        if (errno == EAGAIN)
            return 1; // Worker is not ready
        terminate(errno, "Semaphore is broken (trywait).\n");
    }
    return 0;
}

void sem_post_safe(sem_t *sem)
{
    if (sem_post(sem))
        terminate(errno, "Semaphore is broken (post).\n");
}

void sem_init_safe(sem_t *sem, unsigned val)
{
    if (sem_init(sem, 1, val))
        terminate(errno, "Unable to initialize semaphore.\n");
}

\end{lstlisting}
\newpage
\begin{lstlisting}[firstnumber=last]
TaskStream *makeTaskStream(char *files[], size_t mul)
{
    // Get memory.
    TaskStream *tstream = malloc(sizeof(TaskStream));
    if (!tstream)
        terminate(errno, "Couldn't allocate memory for the TaskStream.\n");
    
    // Size of blocks the files are broken into.
    tstream->step = d_pagesize();
    tstream->step *= mul ? mul : 1;

    // Null-terminated file list.    
    tstream->files = files;

    // First file, First byte.
    tstream->cur_file = 0;
    tstream->cur_off = 0;
    tstream->cur_max = 0;

    return tstream;
}

int getTask(TaskStream *tstream, Task *task)
{
    size_t c_file = tstream->cur_file;
    size_t c_step = tstream->step;
    char **s_files = tstream->files;
    struct stat filestat;
    if (!tstream->cur_max)
    {
        // No tasks left.
        if (!s_files[c_file])
            return 0;

        // Get next file.
        strncpy(task->filename, s_files[c_file], sizeof(task->filename));

        // Get next files size.
        if (stat(s_files[c_file], &filestat))
            terminate(errno, "Couldn't stat file %s.\n", s_files[c_file]);
        tstream->cur_max = filestat.st_size;
    }

    // Update values for next step.
    size_t c_max = tstream->cur_max;
    size_t c_off = tstream->cur_off;
    task->offset = c_off;
    task->amount = (c_step < c_max - c_off) ? c_step : c_max - c_off;
    tstream->cur_off += task->amount;

    if (tstream->cur_off == c_max)
    {
        tstream->cur_file++;
        tstream->cur_max = 0;
        tstream->cur_off = 0;
    }
    return 1;
}

\end{lstlisting}
\newpage
\begin{lstlisting}[firstnumber=last]
Swarm *makeSwarm(size_t K)
{
    // Get shared mapping.
    Swarm *swarm = forkshare(sizeof(Swarm) + K*sizeof(Worker));
    if (!swarm)
        terminate(errno, "Unable to obtain shared memory for the Swarm.\n");
    swarm->worker_num = K;

    // Initialize all workers.
    for (size_t i = 0; i < K; i++)
        makeWorker(&swarm->workers[i]);

    return swarm;
}

void makeWorker(Worker *worker)
{
    // Initialize semaphores.
    sem_init_safe(&worker->hastask, 0);
    sem_init_safe(&worker->hasresult, 0);

    worker->keepfile = false;
    worker->alive = false;
    worker->task.filename[0] = '\0';

    // Spawn worker.
    pid_t p;
    p = fork();
    if (p == -1)
        terminate(errno, "Couldn't fork.\n");
    if (!p)
        workLoop(worker);
}

void pushTask(Worker *worker, Task *task)
{
    if (worker->alive)
        terminate(0, "Trying to push a task to a living worker.\n");
    
    // If still working on the same file, keep it open.
    worker->keepfile = !strcmp(task->filename, worker->task.filename);
    
    // Load next task.
    Task *t = &worker->task;
    t->offset = task->offset;
    t->amount = task->amount;
    strncpy(t->filename, task->filename, sizeof(t->filename));

    // Give the worker a task.
    worker->alive = true;
    sem_post_safe(&worker->hastask);
}

\end{lstlisting}
\newpage
\begin{lstlisting}[firstnumber=last]
int popTask(Worker *worker, double *res)
{
    // Worker is dead only if not initialized or without a task.
    if (!worker->alive)
        return -1;

    // If worker finished, take over.
    if (sem_trywait_safe(&worker->hasresult))
        return 1;

    // Get worker results.
    *res = worker->result;
    worker->alive = false;
    return 0;
}

#define M_PN MAP_PRIVATE | MAP_NORESERVE

void workLoop(Worker *self)
{
    int fd = -1;
    double *src = NULL;
    Task t;
    while (true)
    {
        // Wait for the task.
        sem_wait_safe(&self->hastask);
        t = self->task;

        // Open/Update file.
        if (!self->keepfile)
        {
            if (fd != -1)
                close(fd);
            fd = open(t.filename, O_RDONLY);
        }
        if (fd == -1)
            terminate(errno, "Unable to fopen file %s.\n", t.filename);
        
        // Mmap file contents.
        src = mmap(NULL, t.amount, PROT_READ, M_PN, fd, t.offset);
        if (src == MAP_FAILED)
            terminate(errno, "Unable to mmap the file %s.\n", t.filename);

        // Find minimum in block.
        double res = DBL_MAX;
        double tmp;
        size_t cur = 0;
        size_t num = t.amount/sizeof(double);
        while (cur < num)
        {
            tmp = src[cur];
            res = (res < tmp) ? res : tmp;
            cur++;
        }

        // Unmap.
        if (munmap(src, t.amount))
            terminate(errno, "Unable to munmap file.\n");

        // Return result to overseer.
        self->result = res;
        sem_post_safe(&self->hasresult);
    }
}
\end{lstlisting}
\newpage
\lstset{title=Contents of \texttt{src/examples.c}}
\begin{lstlisting}
#include <float.h>
#include <signal.h>
#include <sys/types.h>
#include <unistd.h>

#include "swarm.h"
#include "terminator.h"

#define K 32

void stop(int i)
{
    (void) i; /* unused */
    _exit(0);
}

int main(int argc, char *argv[])
{
    // Add signal handler, for safe CTRL+C.
    signal(SIGINT, stop);
    // Make terminator I/O functions atomic.
    atomize();
    // Init swarm of processes.
    Swarm *swarm = makeSwarm(K);
    // Init task stream with default step size.
    TaskStream *tstream = makeTaskStream(argv+1, 8);
    Task next;
    // Preload swarm with tasks.
    for (size_t i = 0; i < K; i++)
    {
        if (!getTask(tstream, &next))
            break;
        pushTask(&swarm->workers[i], &next);
    }
    double minval = DBL_MAX;
    double tmp;
    bool all_dead;
    while (1)
    {
        // popTask returns -1 if worker is dead,
        //                  0 if worker is done with current task
        //                  1 if worker is working.
        all_dead = true;
        for (size_t i = 0; i < K; i++)
        {
            int ret = popTask(&swarm->workers[i], &tmp);
            if (!ret)
            {
                if (tmp < minval)
                    announce("New minimum found: %.*e\n", DECIMAL_DIG+1, tmp);
                minval = (minval < tmp) ? minval : tmp;
                // Load next task.
                if (getTask(tstream, &next))
                    pushTask(&swarm->workers[i], &next);
                all_dead = false;
            }
            if (ret == 1)
                all_dead = false;
        }
        if (all_dead)
            break;
    }
    announce("Overall minimum  : %.*e\n", DECIMAL_DIG+1, minval);
    kill(0, SIGINT);
}
\end{lstlisting}
\end{document}
